Index: LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1664)
@@ -1793,5 +1799,5 @@
                zstophym, zoutm(iff))
        endif
-       else
+    else
        if ( flag_var(iff)<=lev_files(iff) ) then
           call histdef (nid_files(iff), nomvar, titrevar, unitvar, &
@@ -1800,69 +1806,70 @@
                type_ecri(iff), zstophym,zoutm(iff))
        endif
-       endif
-      end subroutine histdef3d
-
-      SUBROUTINE conf_physoutputs(nam_var,flag_var)
+    endif
+  end subroutine histdef3d
+
+  SUBROUTINE conf_physoutputs(nam_var,flag_var)
 !!! Lecture des noms et niveau de sortie des variables dans output.def
-!   en utilisant les routines getin de IOIPSL  
-       use ioipsl
-
-       IMPLICIT NONE
-
-       include 'iniprint.h'
-
-       character(len=20)                :: nam_var
-       integer, dimension(nfiles)      :: flag_var
-
-        IF(prt_level>10) WRITE(lunout,*)'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
-        call getin('flag_'//nam_var,flag_var)
-        call getin('name_'//nam_var,nam_var)
-        IF(prt_level>10) WRITE(lunout,*)'Apres getin: nam_var flag_var ',nam_var,flag_var(:)
-
-      END SUBROUTINE conf_physoutputs
-
-      SUBROUTINE convers_timesteps(str,dtime,timestep)
-
-        use ioipsl
-        USE phys_cal_mod
-
-        IMPLICIT NONE
-
-        character(len=20)   :: str
-        character(len=10)   :: type
-        integer             :: ipos,il
-        real                :: ttt,xxx,timestep,dayseconde,dtime
-        parameter (dayseconde=86400.)
-        include "temps.h"
-        include "comconst.h"
-
-        ipos=scan(str,'0123456789.',.true.)
-!  
-        il=len_trim(str)
-        print*,ipos,il
-        read(str(1:ipos),*) ttt
-        print*,ttt
-        type=str(ipos+1:il)
-
-
-        if ( il == ipos ) then
-        type='day'
-        endif
-
-        if ( type == 'day'.or.type == 'days'.or.type == 'jours'.or.type == 'jour' ) timestep = ttt * dayseconde
-        if ( type == 'mounths'.or.type == 'mth'.or.type == 'mois' ) then
-           print*,'annee_ref,day_ref mon_len',annee_ref,day_ref,ioget_mon_len(annee_ref,day_ref)
-           timestep = ttt * dayseconde * mth_len
-        endif
-        if ( type == 'hours'.or.type == 'hr'.or.type == 'heurs') timestep = ttt * dayseconde / 24.
-        if ( type == 'mn'.or.type == 'minutes'  ) timestep = ttt * 60.
-        if ( type == 's'.or.type == 'sec'.or.type == 'secondes'   ) timestep = ttt
-        if ( type == 'TS' ) timestep = dtime
-
-        print*,'type =      ',type
-        print*,'nb j/h/m =  ',ttt
-        print*,'timestep(s)=',timestep
-
-        END SUBROUTINE convers_timesteps
+    !   en utilisant les routines getin de IOIPSL  
+    use ioipsl
+
+    IMPLICIT NONE
+
+    include 'iniprint.h'
+
+    character(len=20)                :: nam_var
+    integer, dimension(nfiles)      :: flag_var
+
+    IF(prt_level>10) WRITE(lunout,*)'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
+    call getin('flag_'//nam_var,flag_var)
+    call getin('name_'//nam_var,nam_var)
+    IF(prt_level>10) WRITE(lunout,*)'Apres getin: nam_var flag_var ',nam_var,flag_var(:)
+
+  END SUBROUTINE conf_physoutputs
+
+  SUBROUTINE convers_timesteps(str,dtime,timestep)
+
+    use ioipsl
+    USE phys_cal_mod
+
+    IMPLICIT NONE
+
+    character(len=20)   :: str
+    character(len=10)   :: type
+    integer             :: ipos,il
+    real                :: ttt,xxx,timestep,dayseconde,dtime
+    parameter (dayseconde=86400.)
+    include "temps.h"
+    include "comconst.h"
+    include "iniprint.h"
+
+    ipos=scan(str,'0123456789.',.true.)
+    !  
+    il=len_trim(str)
+    write(lunout,*)ipos,il
+    read(str(1:ipos),*) ttt
+    write(lunout,*)ttt
+    type=str(ipos+1:il)
+
+
+    if ( il == ipos ) then
+       type='day'
+    endif
+
+    if ( type == 'day'.or.type == 'days'.or.type == 'jours'.or.type == 'jour' ) timestep = ttt * dayseconde
+    if ( type == 'mounths'.or.type == 'mth'.or.type == 'mois' ) then
+       write(lunout,*)'annee_ref,day_ref mon_len',annee_ref,day_ref,ioget_mon_len(annee_ref,day_ref)
+       timestep = ttt * dayseconde * mth_len
+    endif
+    if ( type == 'hours'.or.type == 'hr'.or.type == 'heurs') timestep = ttt * dayseconde / 24.
+    if ( type == 'mn'.or.type == 'minutes'  ) timestep = ttt * 60.
+    if ( type == 's'.or.type == 'sec'.or.type == 'secondes'   ) timestep = ttt
+    if ( type == 'TS' ) timestep = ttt * dtime
+
+    write(lunout,*)'type =      ',type
+    write(lunout,*)'nb j/h/m =  ',ttt
+    write(lunout,*)'timestep(s)=',timestep
+
+  END SUBROUTINE convers_timesteps
 
 END MODULE phys_output_mod
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_write.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_write.h	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_write.h	(revision 1664)
@@ -614,19 +614,20 @@
         ENDIF
 
-        IF (o_plcl%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_plcl%name,itau_w,plcl)
-        ENDIF
-
-        IF (o_plfc%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_plfc%name,itau_w,plfc)
-        ENDIF
-
-        IF (o_wbeff%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_wbeff%name,itau_w,wbeff)
-        ENDIF
-
+        if (iflag_con /= 30) then
+           if (o_plcl%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $             o_plcl%name,itau_w,plcl)
+           ENDIF
+
+           IF (o_plfc%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $             o_plfc%name,itau_w,plfc)
+           ENDIF
+
+           IF (o_wbeff%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $             o_wbeff%name,itau_w,wbeff)
+           ENDIF
+        end if
 
         IF (o_prw%flag(iff)<=lev_files(iff)) THEN
Index: LMDZ5/branches/testing/libf/phylmd/physiq.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq.F	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/physiq.F	(revision 1664)
@@ -42,4 +42,7 @@
       use radlwsw_m, only: radlwsw
       USE control_mod
+#ifdef REPROBUS
+      USE CHEM_REP, ONLY : Init_chem_rep_xjour
+#endif
 
 
@@ -1215,4 +1218,6 @@
       REAL, dimension(klon, klev) :: cldtaurad  ! epaisseur optique pour radlwsw,COSP
       REAL, dimension(klon, klev) :: cldemirad  ! emissivite pour radlwsw,COSP 
+      INTEGER :: nbtr_tmp ! Number of tracer inside concvl
+      REAL, dimension(klon,klev) :: sh_in ! Specific humidity entering in phytrac
 
 cIM for NMC files
@@ -1355,5 +1360,5 @@
          tau_overturning_th(:)=0.
 
-         IF (config_inca /= 'none') THEN
+         IF (type_trac == 'inca') THEN
             ! jg : initialisation jusqu'au ces variables sont dans restart
             ccm(:,:,:) = 0.
@@ -1619,5 +1624,4 @@
 #endif
 
-         ecrit_hf2mth = ecrit_mth/ecrit_hf
 
          ecrit_hf = ecrit_hf * un_jour
@@ -1633,7 +1637,4 @@
          ecrit_LES = ecrit_LES * un_jour
 c
-         PRINT*,'physiq ecrit_ hf day mth reg tra ISCCP hf2mth',
-     .   ecrit_hf,ecrit_day,ecrit_mth,ecrit_reg,ecrit_tra,ecrit_ISCCP,
-     .   ecrit_hf2mth
 
 cXXXPB Positionner date0 pour initialisation de ORCHIDEE
@@ -1652,5 +1653,5 @@
 cc         ENDDO
 c
-      IF (config_inca /= 'none') THEN
+      IF (type_trac == 'inca') THEN
 #ifdef INCA
          CALL VTe(VTphysiq)
@@ -1740,4 +1741,15 @@
       CALL change_srf_frac(itap, dtime, days_elapsed+1, 
      *     pctsrf, falb1, falb2, ftsol, u10m, v10m, pbl_tke)
+
+
+! Update time and other variables in Reprobus
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         CALL Init_chem_rep_xjour(jD_cur-jD_ref+day_ref)
+         print*,'xjour equivalent rjourvrai',jD_cur-jD_ref+day_ref
+         CALL Rtime(debut)
+#endif
+      END IF
+
 
 ! Tendances bidons pour les processus qui n'affectent pas certaines
@@ -2292,8 +2304,13 @@
           IF (ok_cvl) THEN ! new driver for convectL
 
+             IF (type_trac == 'repr') THEN
+                nbtr_tmp=ntra
+             ELSE
+                nbtr_tmp=nbtr
+             END IF
           CALL concvl (iflag_con,iflag_clos,
      .        dtime,paprs,pplay,t_undi,q_undi,
      .        t_wake,q_wake,wake_s,
-     .        u_seri,v_seri,tr_seri,nbtr,
+     .        u_seri,v_seri,tr_seri,nbtr_tmp,
      .        ALE,ALP,
      .        ema_work1,ema_work2,
@@ -3150,5 +3167,5 @@
       ENDDO
 
-      IF (config_inca /= 'none') THEN
+      IF (type_trac == 'inca') THEN
 #ifdef INCA
          CALL VTe(VTphysiq)
@@ -3204,5 +3221,5 @@
          CALL VTb(VTphysiq)
 #endif 
-      END IF !config_inca /= 'none'
+      END IF !type_trac = inca
 c     
 c Calculer les parametres optiques des nuages et quelques
@@ -3668,4 +3685,10 @@
 C
 
+       IF (type_trac=='repr') THEN
+          sh_in(:,:) = q_seri(:,:)
+       ELSE
+          sh_in(:,:) = qx(:,:,ivap)
+       END IF
+
       call phytrac (
      I     itap,     days_elapsed+1,    jH_cur,   debut,
@@ -3677,5 +3700,5 @@
      I     rlat,     frac_impa, frac_nucl,rlon,
      I     presnivs, pphis,     pphi,     albsol1,
-     I     qx(:,:,ivap),rhcl,   cldfra,   rneb, 
+     I     sh_in,    rhcl,      cldfra,   rneb, 
      I     diafra,   cldliq,    itop_con, ibas_con,
      I     pmflxr,   pmflxs,    prfl,     psfl,
@@ -3860,5 +3883,5 @@
 #include "calcul_divers.h"
 c
-      IF (config_inca /= 'none') THEN
+      IF (type_trac == 'inca') THEN
 #ifdef INCA
          CALL VTe(VTphysiq)
Index: LMDZ5/branches/testing/libf/phylmd/phytrac.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phytrac.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/phytrac.F90	(revision 1664)
@@ -33,6 +33,6 @@
   USE traclmdz_mod
   USE tracinca_mod
+  USE tracreprobus_mod
   USE control_mod
-
 
 
@@ -46,4 +46,5 @@
   INCLUDE "paramet.h"
   INCLUDE "thermcell.h"
+  INCLUDE "iniprint.h"
 !==========================================================================
 !                   -- ARGUMENT DESCRIPTION --
@@ -55,5 +56,5 @@
   INTEGER,INTENT(IN) :: nstep      ! Appel physique
   INTEGER,INTENT(IN) :: julien     ! Jour julien
-  REAL,INTENT(IN)    :: gmtime
+  REAL,INTENT(IN)    :: gmtime     ! Heure courante
   REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)
   LOGICAL,INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
@@ -202,5 +203,5 @@
 !######################################################################
   IF (debutphy) THEN
-     WRITE(*,*) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ',pdtphys,'ecrit_tra (sec) = ',ecrit_tra
+     IF (prt_level >9) WRITE(lunout,*) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ',pdtphys,'ecrit_tra (sec) = ',ecrit_tra
      ALLOCATE( source(klon,nbtr), stat=ierr)
      IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 1',1)
@@ -217,4 +218,6 @@
         source(:,:)=0.
         CALL tracinca_init(aerosol,lessivage)
+     CASE('repr')
+        source(:,:)=0.
      END SELECT
 !
@@ -222,5 +225,5 @@
 ! ----------------------------
 #ifdef CPP_IOIPSL
-!     INCLUDE "ini_histrac.h"
+     INCLUDE "ini_histrac.h"
 #endif
   END IF
@@ -257,4 +260,13 @@
           rfname,                                        &
           tr_seri,  source,   solsym)      
+
+  CASE('repr')
+     !   -- CHIMIE REPROBUS --
+
+     CALL tracreprobus(pdtphys, gmtime, debutphy, julien, &
+          presnivs, xlat, xlon, pphis, pphi, &
+          t_seri, pplay, paprs, sh , &
+          tr_seri, solsym)
+     
   END SELECT
 
@@ -403,5 +415,5 @@
 !=============================================================
 #ifdef CPP_IOIPSL
-!  INCLUDE "write_histrac.h"
+  INCLUDE "write_histrac.h"
 #endif
 
Index: LMDZ5/branches/testing/libf/phylmd/press_coefoz_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/press_coefoz_m.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/press_coefoz_m.F90	(revision 1664)
@@ -60,5 +60,7 @@
        press_in_edg(1) = 0.
        ! We choose edges halfway in logarithm:
-       forall (k = 2:n_plev) press_in_edg(k) = sqrt(plev(k - 1) * plev(k))
+       DO k = 2,n_plev
+          press_in_edg(k) = SQRT(plev(k - 1) * plev(k))
+       ENDDO
        press_in_edg(n_plev + 1) = huge(0.)
        ! (infinity, but any value guaranteed to be greater than the
Index: LMDZ5/branches/testing/libf/phylmd/radiation_AR4.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/radiation_AR4.F	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/radiation_AR4.F	(revision 1664)
@@ -19,4 +19,5 @@
 cym#include "raddim.h"
 #include "YOMCST.h"
+#include "iniprint.h"
 C
 C     ------------------------------------------------------------------
@@ -163,17 +164,14 @@
         allocate(ZFSUPAI(KDLON,KFLEV+1))
         allocate(ZFSDNAI(KDLON,KFLEV+1))
-        DO JK = 1 , KDLON*(KFLEV+1)
-          ZFSUPAD(JK,1) = 0.0     ! ZFSUPAD(:,:)=0.
-          ZFSDNAD(JK,1) = 0.0     ! ZFSDNAD(:,:)=0.
-          ZFSUPAI(JK,1) = 0.0     ! ZFSUPAI(:,:)=0.
-          ZFSDNAI(JK,1) = 0.0     ! ZFSDNAI(:,:)=0.
-        END DO
+
+        ZFSUPAD(:,:)=0.
+        ZFSDNAD(:,:)=0.
+        ZFSUPAI(:,:)=0.
+        ZFSDNAI(:,:)=0.
       endif
-!rv
-      
-c
+
       IF (appel1er) THEN
-         PRINT*, 'SW calling frequency : ', swpas
-         PRINT*, "   In general, it should be 1"
+         WRITE(lunout,*) 'SW calling frequency : ', swpas
+         WRITE(lunout,*) "   In general, it should be 1"
          appel1er = .FALSE.
       ENDIF
@@ -526,8 +524,14 @@
       USE dimphy
       USE radiation_AR4_param, only : RSUN, RRAY
+      USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+      USE CHEM_REP, ONLY : RSUNTIME, ok_SUNTIME
+#endif
+
       IMPLICIT none
 cym#include "dimensions.h"
 cym#include "dimphy.h"
-cym#include "raddim.h"
+cym#include "raddim.h"i
+#include "iniprint.h"
 C
 C     ------------------------------------------------------------------
@@ -613,4 +617,16 @@
       INTEGER jl, jk, k, jaj, ikm1, ikl
 
+C If running with Reporbus, overwrite default values of RSUN. 
+C Otherwise keep default values from radiation_AR4_param module.  
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         IF (ok_SUNTIME) THEN
+            RSUN(1) = RSUNTIME(1)
+            RSUN(2) = RSUNTIME(2)
+         ENDIF
+         WRITE(lunout,*)'RSUN(1): ',RSUN(1)
+#endif
+      END IF
+
 C     ------------------------------------------------------------------
 C
@@ -754,4 +770,9 @@
       USE dimphy
       USE radiation_AR4_param, only : RSUN, RRAY
+      USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+      use CHEM_REP, only : RSUNTIME, ok_SUNTIME
+#endif
+
       IMPLICIT none
 cym#include "dimensions.h"
@@ -873,4 +894,16 @@
       INTEGER jref, jkl, jklp1, jajp, jkki, jkkp4, jn2j, iabs
       REAL(KIND=8) ZRMUM1, ZWH2O, ZCNEB, ZAA, ZBB, ZRKI, ZRE11
+
+C If running with Reporbus, overwrite default values of RSUN. 
+C Otherwise keep default values from radiation_AR4_param module.  
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         IF (ok_SUNTIME) THEN
+            RSUN(1)=RSUNTIME(1)
+            RSUN(2)=RSUNTIME(2)
+         END IF
+#endif
+      END IF
+
 C
 
@@ -2307,4 +2340,5 @@
 #include "raddimlw.h"
 #include "YOMCST.h"
+#include "iniprint.h"
 C
 C-----------------------------------------------------------------------
@@ -2412,7 +2446,7 @@
 C     ------------------------------------------------------------------
       IF (appel1er) THEN
-         PRINT*, "LW clear-sky calling frequency: ", lw0pas
-         PRINT*, "LW cloudy-sky calling frequency: ", lwpas
-         PRINT*, "   In general, they should be 1"
+         WRITE(lunout,*) "LW clear-sky calling frequency: ", lw0pas
+         WRITE(lunout,*) "LW cloudy-sky calling frequency: ", lwpas
+         WRITE(lunout,*) "   In general, they should be 1"
 cym
 	 allocate(ZFLUX(KDLON,2,KFLEV+1) )
@@ -2485,4 +2519,13 @@
       USE dimphy
       USE radiation_AR4_param, only : TREF, RT1, RAER, AT, BT, OCT
+      USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+      USE CHEM_REP, ONLY: RCH42D,
+     $                    RN2O2D,
+     $                    RCFC112D,
+     $                    RCFC122D,
+     $                    ok_Rtime2D
+#endif
+
       IMPLICIT none
 cym#include "dimensions.h"
@@ -2800,17 +2843,55 @@
      S                +ZUAER(JL,5)    *ZDUC(JL,JC)*ZDIFF
 C
-      PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
-     S               +ZABLY(JL,8,JC)*RCH4/RCO2*ZPHM6(JL)*ZDIFF
-      PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
+C
+
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         IF (ok_Rtime2D) THEN
+            PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
+     S           +ZABLY(JL,8,JC)*RCH42D(JL,JC)/RCO2*ZPHM6(JL)*ZDIFF
+            PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
+     S           +ZABLY(JL,9,JC)*RCH42D(JL,JC)/RCO2*ZPSM6(JL)*ZDIFF
+            PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
+     S           +ZABLY(JL,8,JC)*RN2O2D(JL,JC)/RCO2*ZPHN6(JL)*ZDIFF
+            PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
+     S           +ZABLY(JL,9,JC)*RN2O2D(JL,JC)/RCO2*ZPSN6(JL)*ZDIFF
+C
+            PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
+     S           +ZABLY(JL,8,JC)*RCFC112D(JL,JC)/RCO2         *ZDIFF
+            PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
+     S           +ZABLY(JL,8,JC)*RCFC122D(JL,JC)/RCO2         *ZDIFF
+         ELSE
+            ! Same calculation as for type_trac /= repr
+            PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
+     S           +ZABLY(JL,8,JC)*RCH4/RCO2*ZPHM6(JL)*ZDIFF
+            PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
+     S           +ZABLY(JL,9,JC)*RCH4/RCO2*ZPSM6(JL)*ZDIFF
+            PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
+     S           +ZABLY(JL,8,JC)*RN2O/RCO2*ZPHN6(JL)*ZDIFF
+            PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
+     S           +ZABLY(JL,9,JC)*RN2O/RCO2*ZPSN6(JL)*ZDIFF
+C     
+            PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
+     S               +ZABLY(JL,8,JC)*RCFC11/RCO2         *ZDIFF
+            PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
+     S           +ZABLY(JL,8,JC)*RCFC12/RCO2         *ZDIFF
+         END IF
+#endif
+      ELSE
+         PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
+     S        +ZABLY(JL,8,JC)*RCH4/RCO2*ZPHM6(JL)*ZDIFF
+         PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
      S               +ZABLY(JL,9,JC)*RCH4/RCO2*ZPSM6(JL)*ZDIFF
-      PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
-     S               +ZABLY(JL,8,JC)*RN2O/RCO2*ZPHN6(JL)*ZDIFF
-      PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
-     S               +ZABLY(JL,9,JC)*RN2O/RCO2*ZPSN6(JL)*ZDIFF
-C
-      PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
-     S               +ZABLY(JL,8,JC)*RCFC11/RCO2         *ZDIFF
-      PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
-     S               +ZABLY(JL,8,JC)*RCFC12/RCO2         *ZDIFF
+         PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
+     S        +ZABLY(JL,8,JC)*RN2O/RCO2*ZPHN6(JL)*ZDIFF
+         PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
+     S        +ZABLY(JL,9,JC)*RN2O/RCO2*ZPSN6(JL)*ZDIFF
+C     
+         PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
+     S        +ZABLY(JL,8,JC)*RCFC11/RCO2         *ZDIFF
+         PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
+     S        +ZABLY(JL,8,JC)*RCFC12/RCO2         *ZDIFF
+      END IF
+      
  523  CONTINUE
  524  CONTINUE
Index: LMDZ5/branches/testing/libf/phylmd/radiation_AR4_param.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/radiation_AR4_param.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/radiation_AR4_param.F90	(revision 1664)
@@ -159,5 +159,6 @@
       0.90811926E+01,  0.75073923E+02,  0.24654438E+03,  0.39332612E+03,  0.29385281E+03,  0.89107921E+02 /) , (/ 6,6 /) )
 
-      REAL*8, dimension(2), parameter :: RSUN = (/ 0.441676 , 0.558324 /)
+! If running with Reporbus type_trac=repr, values of RSUN might be overritten in radiation_AR4
+      REAL*8, dimension(2) :: RSUN = (/ 0.441676 , 0.558324 /)
       REAL*8, dimension(2,6), parameter :: RRAY = reshape ( &
          (/ .428937E-01, .697200E-02,&
Index: LMDZ5/branches/testing/libf/phylmd/radlwsw.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/radlwsw.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/radlwsw.F90	(revision 1664)
@@ -30,5 +30,9 @@
 
   USE DIMPHY
-  use assert_m, only: assert
+  USE assert_m, ONLY : assert
+  USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+  USE CHEM_REP, ONLY : solaireTIME, ok_SUNTIME, ndimozon
+#endif
 
   !======================================================================
@@ -229,4 +233,12 @@
   !
   PSCT = solaire/zdist/zdist
+
+  IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+     if(ok_SUNTIME) PSCT = solaireTIME/zdist/zdist
+     print*,'Constante solaire: ',PSCT*zdist*zdist
+#endif
+  END IF
+
   DO j = 1, nb_gr
     iof = kdlon*(j-1)
@@ -281,4 +293,12 @@
       ENDDO
     ENDDO
+
+    IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+       ndimozon = size(wo, 3)
+       CALL RAD_INTERACTIF(POZON,iof)
+#endif
+    END IF
+
     !
     DO k = 1, kflev+1
Index: LMDZ5/branches/testing/libf/phylmd/soil.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/soil.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/soil.F90	(revision 1664)
@@ -54,4 +54,5 @@
   INCLUDE "indicesol.h"
   INCLUDE "comsoil.h"
+  INCLUDE "iniprint.h"
 !-----------------------------------------------------------------------
 ! Arguments
@@ -111,6 +112,6 @@
            READ(99,*) min_period
            READ(99,*) dalph_soil
-           PRINT*,'Discretization for the soil model'
-           PRINT*,'First level e-folding depth',min_period, &
+           WRITE(lunout,*)'Discretization for the soil model'
+           WRITE(lunout,*)'First level e-folding depth',min_period, &
                 '   dalph',dalph_soil
            CLOSE(99)
@@ -135,10 +136,10 @@
      ENDDO
      lambda=fz(.5)*dz1(1)
-     PRINT*,'full layers, intermediate layers (seconds)'
+     WRITE(lunout,*)'full layers, intermediate layers (seconds)'
      DO jk=1,nsoilmx
         rk=jk
         rk1=jk+.5
         rk2=jk-.5
-        PRINT *,'fz=', &
+        WRITE(lunout,*)'fz=', &
              fz(rk1)*fz(rk2)*3.14,fz(rk)*fz(rk)*3.14
      ENDDO
@@ -175,5 +176,5 @@
      ENDDO
   ELSE
-     PRINT*, "valeur d indice non prevue", indice
+     WRITE(lunout,*) "valeur d indice non prevue", indice
      CALL abort
   ENDIF
Index: LMDZ5/branches/testing/libf/phylmd/sw_aeroAR4.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/sw_aeroAR4.F90	(revision 1663)
+++ LMDZ5/branches/testing/libf/phylmd/sw_aeroAR4.F90	(revision 1664)
@@ -26,4 +26,5 @@
 #include "YOMCST.h"
 #include "clesphys.h"
+#include "iniprint.h"
   !
   !     ------------------------------------------------------------------
@@ -225,6 +226,6 @@
 
   IF (appel1er) THEN
-     PRINT*, 'SW calling frequency : ', swpas
-     PRINT*, "   In general, it should be 1"
+     WRITE(lunout,*) 'SW calling frequency : ', swpas
+     WRITE(lunout,*) "   In general, it should be 1"
      appel1er = .FALSE.
   ENDIF
Index: LMDZ5/branches/testing/libf/phylmd/tracreprobus_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/tracreprobus_mod.F90	(revision 1664)
+++ LMDZ5/branches/testing/libf/phylmd/tracreprobus_mod.F90	(revision 1664)
@@ -0,0 +1,109 @@
+MODULE tracreprobus_mod
+!
+! This module prepares and calls the Reprobus main subroutine 
+!
+
+CONTAINS
+
+  SUBROUTINE tracreprobus(pdtphys, gmtime, debutphy, julien, &
+       presnivs, xlat, xlon, pphis, pphi, &
+       t_seri, pplay, paprs, sh , &
+       tr_seri, solsym)
+
+    USE dimphy
+    USE infotrac
+#ifdef REPROBUS 
+    USE CHEM_REP, ONLY : pdt_rep, &  ! pas de temps reprobus
+         daynum, iter, &             ! jourjulien, iteration chimie
+         pdel
+#endif
+    IMPLICIT NONE
+
+! Input argument
+!---------------
+    REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)
+    REAL,INTENT(IN)    :: gmtime     ! Heure courante
+    LOGICAL,INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
+    INTEGER,INTENT(IN) :: julien     ! Jour julien
+
+    REAL,DIMENSION(klev),INTENT(IN)        :: presnivs! pressions approximat. des milieux couches (en PA)
+    REAL,DIMENSION(klon),INTENT(IN)        :: xlat    ! latitudes pour chaque point 
+    REAL,DIMENSION(klon),INTENT(IN)        :: xlon    ! longitudes pour chaque point 
+    REAL,DIMENSION(klon),INTENT(IN)        :: pphis   ! geopotentiel du sol
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pphi    ! geopotentiel de chaque couche
+
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique   
+
+
+! Output argument
+!----------------
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]  
+    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
+  
+
+! Local variables
+!----------------
+    INTEGER :: it, k
+
+#ifdef REPROBUS
+    !   -- CHIMIE REPROBUS --
+    pdt_rep=pdtphys/2.
+    
+    DO k = 1, klev
+       pdel(:,k) = paprs(:,k) - paprs (:,k+1)
+    END DO
+    
+    ! initialisation de ozone passif a ozone en debut d hiver HN et HS
+    IF (julien == 341 .OR. julien == 181) THEN
+       tr_seri(:,:,11)=tr_seri(:,:,8)
+    END IF
+    
+    DO  iter = 1,2
+       daynum = FLOAT(julien) + gmtime + (iter-1)*pdt_rep/86400.
+       
+       DO it=1, nbtr
+!     WRITE(lunout,*)it,' ',minval(tr_seri(:,:,it)),maxval(tr_seri(:,:,it))
+! seulement pour les especes chimiques (pas l'age de l'air)
+! verif valeurs extremes
+! correction: a 1.e-30 quand =0 ou negatif et
+! call abort si >ou= 1.e10
+          WRITE(*,*)it,'nqtot',nqtot,'nbtr',nbtr
+          IF (it < nqtot) THEN
+             WRITE(*,*)'ici',it,nqtot
+#ifdef REPROBUS
+             CALL minmaxqfi_chimie(tr_seri(1,1,it),0.,1.e10,'avant chimie ')
+#endif
+             WRITE(*,*)'apres'
+          ENDIF
+       ENDDO
+       
+#ifdef REPROBUS
+       CALL chemmain_rlong_1401( &
+            tr_seri, & !argument phytrac (change de nom apres: vmr)
+            xlon,    & !argument phytrac (change de nom apres: lon)
+            xlat,    & !argument phytrac (change de nom apres: lat)
+            t_seri,  & !argument phytrac (meme nom)
+            pplay,   & !argument phytrac (meme nom)
+            pphi,    & !argument phytrac (meme nom)
+            pphis,   & !argument phytrac (meme nom)
+            presnivs, & !argument phytrac (meme nom)
+            sh,      & !argument phytrac (meme nom)
+            debutphy) !argument phytrac (change de nom apres: debut)
+       ! pdel, pdt_rep, daynum : definit dans phytrac et utilise dans chemmain
+       !                 et transporte par CHEM_REP
+#endif        
+       
+    END DO
+    
+
+    ! 
+    DO it=1,nbtr
+       WRITE(solsym(it),'(i2)') it
+    END DO
+#endif
+  END SUBROUTINE tracreprobus
+
+END MODULE tracreprobus_mod
